-- Lua Script1
-- Author: LeeS
-- 14June2016
--------------------------------------------------------------


local iGreatGeneral = GameInfoTypes.UNIT_GREAT_GENERAL



function GetCivSpecificUnitForDefaultUnit(pPlayer, iDefaultUnit)
	local sUnitClass = GameInfo.Units[iDefaultUnit].Class
	local sCivilizationName = GameInfo.Civilizations[pPlayer:GetCivilizationType()].Type
	for row in GameInfo.Civilization_UnitClassOverrides("CivilizationType='" .. sCivilizationName .. "'") do
		if row.UnitClassType == sUnitClass then
			if row.UnitType ~= "NULL" and row.UnitType ~= "NONE" and row.UnitType ~= nil then
				return GameInfoTypes[row.UnitType]
			end
		end
	end
	return iDefaultUnit
end

function MonitorGreatGeneralProgress(iPlayer)
	local pPlayer = Players[iPlayer]
	if pPlayer:IsBarbarian() then return end

	if pPlayer:GetCombatExperience() >= pPlayer:GreatGeneralThreshold() then
		local iCombatThreshold = pPlayer:GreatGeneralThreshold()
		local pCapital = pPlayer:GetCapitalCity()
		local iUnitTypeToSpawn = GetCivSpecificUnitForDefaultUnit(pPlayer, iGreatGeneral)
		pPlayer:CreateGreatGeneral(iUnitTypeToSpawn, pCapital:GetX(), pCapital:GetY())
		pPlayer:ChangeCombatExperience(iCombatThreshold * -1)
		--print("AFTER the Great General Spawn, " .. pPlayer:GetName() .. "'s Great General Threshold is " .. pPlayer:GreatGeneralThreshold() .. " and thier current combat experience is " .. pPlayer:GetCombatExperience())
	else
		--print(pPlayer:GetName() .. "'s Great General Threshold is " .. pPlayer:GreatGeneralThreshold() .. " and thier current combat experience is " .. pPlayer:GetCombatExperience())
	end
end
GameEvents.PlayerDoTurn.Add(MonitorGreatGeneralProgress)


print("At least the lua tester for curing Great General Generation bug loaded")



